/* KOHONEN.C */

#include <stdio.h>
#include <math.h>
#include <stdlib.h>

float w[3][144],w1,w2,testx,testy,dist,bestdist;
int i,j,k,c,besti=0,bestj=0;

int index(int i,int j);
void normalize(float *x, float *y);

main(){
    /* initialize weights */
    clrscr();
    puts("Please wait.  This takes a while.");
    randomize();
    for (j=0;j<144;j++) {
        w1=random(1000)/1000.0-0.5;
        w2=random(1000)/1000.0-0.5;
	normalize(&w1,&w2);
	w[1][j]=w1;
	w[2][j]=w2;
    }

    /* adjust weights */
       for (k=1;k<=100;k++){
	 testx=0;testy=0;
	 while (testx+testy == 0) {
	   testx=3*random(2)+random(1000)/1000.00-0.5;
	   testy=3*random(2)+random(1000)/1000.00-0.5;
	 }
       normalize(&testx,&testy);

       /* find the closest node */

       bestdist=10.0;
       for(i=1;i<=10;i++)
         for(j=1;j<=10;j++){
            dist=2-2*(testx*w[1][index(i,j)]+testy*w[2][index(i,j)]);
            if (dist<bestdist) {
                besti=i;
                bestj=j;
                bestdist=dist;
	    }    /* end if */
	}    /* end for loops */

	/* adjust weights */

	for (i=besti-1;i<=besti+1;i++)
	  for (j=bestj-1;j<=bestj+1;j++) {
	     w[1][index(i,j)]=(w[1][index(i,j)]+testx)/2.0;
	     w[2][index(i,j)]=(w[2][index(i,j)]+testy)/2.0;
	     normalize(&w[1][index(i,j)],&w[2][index(i,j)]);
	}  /* end for loops */




      }         /* go get another test point */

      clrscr();

      for(k=1;k<=3;k++){
       printf("Press a key for pattern %d.\n",k);
       getch();
       testx=k % 2 ;
       testy=(k/2) ;
       normalize(&testx,&testy);

       for(i=1;i<=10;i++){
         for(j=1;j<=10;j++){
	    dist=2-2*(testx*w[1][index(i,j)]+testy*w[2][index(i,j)]);
	    if (dist<.1) c='*';
	    else c='-';

	    printf("%c",c);
	 }   /* end j loop */
	 printf("\n");

	}    /* end i loop */
      } /* end k loop */



} /* end main */

int index(int i, int j) {
    int k;
    k=12*i+j;
    return(k);
}    /* end of index function */

void normalize(float *x, float *y){
    float dist;
    dist=sqrt(*x**x + *y**y);
    *x=*x/dist;
    *y=*y/dist;
} /*end normalize */

/* end KOHONEN.C */